--
-- Excavators Tracks Position for FS17
-- This mod show you current position of tracks against the cab of your excavator.
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0 - 2017-11-14 - 
-- 
ExcavatorsTracksPosition = {};
local ExcavatorsTracksPosition_directory = g_currentModDirectory;
function ExcavatorsTracksPosition.prerequisitesPresent(specializations)
    return true;
end;

function ExcavatorsTracksPosition:load(savegame)
	self.etp = {};
	self.etp.positionX = 0.86;
	self.etp.positionY = 0.179;
	self.etp.showPosX = self.etp.positionX - 0.14
    self.etp.showWidth = 0.11;
    self.etp.showPosY = self.etp.positionY - 0.105;
    self.etp.showHeight = 0.16;
	self.etp.showPosX2 = self.etp.positionX - 0.145;
    self.etp.showWidth2 = 0.12;
    self.etp.showPosY2 = self.etp.positionY - 0.105;
    self.etp.showHeight2 = 0.16;
	self.etp.showRPMHudOverlay = Overlay:new("RPMHUDOverlay", Utils.getFilename("excav.dds", ExcavatorsTracksPosition_directory), self.etp.showPosX, self.etp.showPosY, self.etp.showWidth, self.etp.showHeight);
	self.etp.showRPMHudOverlay2 = Overlay:new("RPMHUDOverlay2", Utils.getFilename("tracks.png", ExcavatorsTracksPosition_directory), self.etp.showPosX2, self.etp.showPosY2, self.etp.showWidth2, self.etp.showHeight2);
	self.etp.hud = Overlay:new("InfoHUD", Utils.getFilename("Info_hud.dds", ExcavatorsTracksPosition_directory), self.etp.positionX - 0.115, self.etp.positionY - 0.145, 0.06, 0.174);
	self.etp.active = false
	self.etp.reverse = false
	if self.movingTools ~= 0 and self.movingTools ~= nil and self.movingTools[1] ~= nil then
		for _,tool in pairs(self.movingTools) do
			if(tool.axis == "AXIS_CRANE_ARM" or tool.axis == "AXIS_FRONTLOADER_ARM" or tool.axis == "AXIS_CRANE_TOOL" or tool.axis == "AXIS_FRONTLOADER_TOOL") and ((tool.rotMax == nil and tool.rotMin == nil) or tool.rotMax == tool.rotMin * -1) then
				self.etp.active = true
				self.etp.toolAxis = tool
			end
		end
	end
end;

function ExcavatorsTracksPosition:postLoad(savegame) 
	if savegame ~= nil then
		local reverse = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key .. "#etp.reverse"), self.etp.reverse);
		self.etp.reverse = reverse;
	end;
end;

function ExcavatorsTracksPosition:delete()
end;

function ExcavatorsTracksPosition:readStream(streamId, connection)
end;

function ExcavatorsTracksPosition:writeStream(streamId, connection)
end;

function ExcavatorsTracksPosition:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ExcavatorsTracksPosition:keyEvent(unicode, sym, modifier, isDown)
end;

function ExcavatorsTracksPosition:update(dt)
	if self:getIsActive() then
			if self.etp.active == true then
				--print(self.etp.toolAxis.axis)
				--print(math.deg(self.etp.toolAxis.curRot[2]))
				self.etp.showRPMHudOverlay2:setRotation((self.etp.toolAxis.curRot[2] * -1) - math.rad(self.etp.reverse and 180 or 0),  self.etp.showWidth2/2,  self.etp.showHeight2/3.8);
			end
		if InputBinding.hasEvent(InputBinding.REVERSE_DIRECTION) then
			self.etp.reverse = not self.etp.reverse;
		end;
	end
end;

function ExcavatorsTracksPosition:updateTick(dt)
end;

function ExcavatorsTracksPosition:draw()
	if self:getIsActiveForInput() then
		if self.etp.active == true then
			self.etp.hud:render();
			self.etp.showRPMHudOverlay2:render();
			self.etp.showRPMHudOverlay:render();
			g_currentMission:addHelpButtonText(g_i18n:getText("input_REVERSE_DIRECTION"),InputBinding.REVERSE_DIRECTION);
		end
	end
end;

function ExcavatorsTracksPosition:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'etp.reverse="' .. tostring(self.etp.reverse) ..'"';
	return attributes;
end;

function ExcavatorsTracksPosition:onLeave()
end;