--
-- Excavators Tracks Position for FS17
-- This mod show you current position of tracks against the cab of your excavator.
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0 - 2017-11-14 - 
-- 
SpecializationUtil.registerSpecialization("ExcavatorsTracksPosition", "ExcavatorsTracksPosition", g_currentModDirectory.."ExcavatorsTracksPosition.lua");

ExcavatorsTracksPosition_register = {};
if SpecializationUtil.specializations["ExcavatorsTracksPosition"] == nil then
	SpecializationUtil.registerSpecialization("ExcavatorsTracksPosition", "ExcavatorsTracksPosition", g_currentModDirectory.."ExcavatorsTracksPosition.lua");
	ExcavatorsTracksPosition_register.isLoaded = false; 
end;

function ExcavatorsTracksPosition_register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		print("Excavators Tracks Position mod loaded")
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and vs == SpecializationUtil.getSpecialization("drivable") then
						local v_name_string = v.name 
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local _name = string.sub(v_name_string, 1, point_location-1);
							if rawget(SpecializationUtil.specializations, string.format("%s.ExcavatorsTracksPosition", _name)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						if allowInsertion then	
							table.insert(v.specializations, SpecializationUtil.getSpecialization("ExcavatorsTracksPosition"));
							--g_i18n.globalI18N.texts["REVERSE_DIRECTION"] = g_i18n:getText("REVERSE_DIRECTION")
							allowInsertion = false;
						end;
					end;
				end;
			end;	
		end;
	end;
end;
function ExcavatorsTracksPosition_register:deleteMap()
end;
function ExcavatorsTracksPosition_register:keyEvent(unicode, sym, modifier, isDown)
end;
function ExcavatorsTracksPosition_register:mouseEvent(posX, posY, isDown, isUp, button)
end;
function ExcavatorsTracksPosition_register:update(dt)
end;
function ExcavatorsTracksPosition_register:draw()
end;

addModEventListener(ExcavatorsTracksPosition_register);
